<?php

/**
 *
 * @author: xaboy<365615158@qq.com>
 * @day: 2017/11/02
 */

namespace app\models\auction;

use app\admin\model\user\User;
use app\admin\model\user\UserBill;
use crmeb\services\product\Product;
use crmeb\traits\ModelTrait;
use crmeb\basic\BaseModel;

/**
 * 预约 Model
 * Class WechatNews
 * @package app\admin\model\wechat
 */
class AuctionOrder extends BaseModel
{

    use ModelTrait;

    protected $pk = 'id';

    protected $name = 'auction_order';
    protected $autoWriteTimestamp = true;


    /**
     * 用户订单
     * @param $data
     * @param $uid
     * @return \think\Collection
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function userOrder($data,$uid)
    {
        if ($data['type'] == 1){
            $list = self::where([['uid', '=', $uid], ['status', '=', 1]])->page($data['page'], $data['limit'])->select()->toArray(); //待上传订单

        }else if($data['type'] == 2){
            $list = self::where([['uid', '=', $uid], ['status', '=', 2]])->page($data['page'], $data['limit'])->select()->toArray(); //待审核订单

        }else if($data['type'] == 3) {
            $list = self::where([['uid', '=', $uid], ['status', '=', 3]])->page($data['page'], $data['limit'])->select()->toArray(); //完成订单
        }else{

            $list = self::where([['uid', '=', $uid], ['status', '<', 1]])->page($data['page'], $data['limit'])->select()->toArray(); //过期订单
        }

        return $list;
    }

    /**
     * 卖家订单
     * @param $data
     * @param $uid
     * @return \think\Collection
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function seller_list($data,$uid)
    {
        if ($data['type'] == 1){
            $list = self::where([['collection_id', '=', $uid], ['status', '=', 1]])->page($data['page'], $data['limit'])->select()->toArray(); //待上传订单

        }else if($data['type'] == 2){
            $list = self::where([['collection_id', '=', $uid], ['status', '=', 2]])->page($data['page'], $data['limit'])->select()->toArray(); //待审核订单

        }else if($data['type'] == 3) {
            $list = self::where([['collection_id', '=', $uid], ['status', '=', 3]])->page($data['page'], $data['limit'])->select()->toArray(); //完成订单
        }else{

            $list = self::where([['collection_id', '=', $uid], ['status', '<', 1]])->page($data['page'], $data['limit'])->select()->toArray(); //过期订单
        }

        return $list;
    }

    /**
     * 卖家操作
     * @param $id  //商品所属人
     * @param $price //卖出价格
     * @param $product //商品详情
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function earn($id, $price,$product)
    {
        $userModel = new \app\models\user\User();
        $productModel = new AuctionProduct();
        $user = $userModel->find($id);
        if ($user['spread_uid'] > 0){
            $s_price = number_format(($price - $product['price']) * 0.1, 2); // 卖出价格减去购买价格的百分之十 为上级直推奖励
            $spread = $userModel->find($user['spread_uid']);
            $spread['integral'] = $spread['integral'] + $s_price; //积分增加
            $spread->save();
            \app\models\user\UserBill::create([
                'uid' => $spread['uid'],
                'link_id' => $id,
                'pm' => 1,
                'title' => '积分增加',
                'category' => 'integral',
                'type' => 'gain',
                'mark' => '卖出商品直推'.$s_price.'积分',
                'add_time' => time(),
                'number' => $s_price,
                'balance' => $spread['integral']

            ]);
            $user['anticipate'] = $user['anticipate']-number_format($price*($product['deduct']/100),2); // 扣除当前卖出价格百分比的预约卷
            $user->save();
            \app\models\user\UserBill::create([
                'uid' => $user['uid'],
                'pm' => 0,
                'title' => '预约卷扣除',
                'category' => 'anticipate',
                'type' => 'reduce_anticipate',
                'mark' => '卖出商品扣除'.number_format($price*($product['deduct']/100), 2).'预约卷',
                'add_time' => time(),
                'number' => number_format($price*($product['deduct']/100),2),
                'balance' => $user['anticipate']
            ]);
        }
        $productModel->where('id', $product['id'])->save(['price' => $price, 'hanging_price' => ($price+$price*($product['rise']/100))]); //修改当前画价

    }

    /**
     * 购买成功退预约卷
     * @param $id
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function return($id)
    {
        $data = self::find($id);
        $userModel = new User();
        $productModel = new AuctionProduct();
        $auctionModel = new Auction();
        $bookingModel = new AuctionBooking();


        $user = $userModel->find($data['uid']);
        if ($user['is_new'] == 1){

            if ($user['spread_uid']) {
                $spread = $userModel->where('id', $user['spread_uid'])->find();
                $spread['green_time'] = strtotime(date('Y-m-d', strtotime('+1 day'))); // 开启明天的绿色通道
            }
            $orderCount = AuctionOrder::where([['uid', '=',  $user['uid']], ['status', 3]])->count();
            if ($orderCount >= 5){
                $user['is_new'] = 0;
            }


        }
        $product = $productModel->where('id', $data['product_id'])->find();
        $auction = $auctionModel->where('id', $product['auction_id'])->find();
        $booking = $bookingModel->where('auction_id', $auction['id'])->whereBetweenTime('create_time', date('Y-m-d H:i:s', strtotime(date('Y-m-d'))), date('Y-m-d H:i:s', strtotime('+1 day')))->find();
        if ($booking['status'] > 0){
            $booking['status'] = 0;
            $booking->save();
            $user['anticipate'] = $user['anticipate'] + $auction['anticipate'];// 退还预约卷
            $user->save();


            \app\models\user\UserBill::create([
                'uid' => $user['uid'],
                'pm' => 1,
                'title' => '预约卷退还',
                'category' => 'anticipate',
                'type' => 'add_anticipate',
                'mark' => '退还预约场馆'.number_format($auction['anticipate'],2).'预约卷',
                'add_time' => time(),
                'number' => number_format($auction['anticipate'],2),
                'balance' => $user['anticipate']
            ]);
        }
    }

    /**
     * 订单过期
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function deduction()
    {
        $hour = strtotime(date('Y-m-d H:i:s', strtotime('-1 hour'))); // 一小时以前

        $order = AuctionOrder::where('create_time', '<', $hour)->where('status', '=', 1)->select(); // 查询不在当前一个小时内的订单
        if ($order){
            foreach ($order as $K => $v){
                $product = AuctionProduct::where('id', $v['product_id'])->find();

                $auction = Auction::where('id', $product['auction_id'])->find();

                $booking = AuctionBooking::whereBetweenTime('create_time',date('Y-m-d H:i:s',  strtotime(date('Y-m-d', time()))), date('Y-m-d H:i:s', strtotime(date('Y-m-d', strtotime('+1 day')))))
                    ->where([['uid', '=', $v['uid']], ['status', '=', 1], ['auction_id', '=', $auction['id']]])->where('status', '=', 1)->find();
                $user = \app\models\user\User::where('uid', $v['collection_id'])->find();

                $user['anticipate'] = $user['anticipate'] + $auction['anticipate'];
                UserBill::income('增加预约卷', $v['collection_id'], 'anticipate', 'add_anticipate',  $auction['anticipate'], $v['uid'], $user['anticipate'], '卖出订单未上传支付凭证,增加'.$auction['anticipate'].'预约卷');

                $user->save();
                AuctionBooking::where('id', $booking['id'])->update(['status' => 0]);
                AuctionOrder::where('create_time', '<', $hour)->where('status', '=', 1)->update(['status' => 2]); // 修改为已过期订单

            }

        }
    }

    /**
     * 退回预约卷
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public static function th()
    {
        $auction = Auction::where('rend_time', '<', time())->select();
        if ($auction){
            foreach ($auction as $k => $v){
                $booking = AuctionBooking::where('auction_id', $v['id'])->whereBetweenTime('create_time',date('Y-m-d H:i:s',  strtotime(date('Y-m-d', time()))), date('Y-m-d H:i:s', strtotime(date('Y-m-d', strtotime('+1 day')))))->select();
                if ($booking){
                    $user = User::where('uid', $booking['uid'])->find();
                    $user['anticipate'] = $user['anticipate'] + $booking['anticipate'];
                    $user->save();
                    UserBill::income('预约卷增加',$user['uid'], 'anticipate', 'add_anticipate', $booking['anticipate'], 0, $user['anticipate'], '预约卷退回');

                }
            }
        }
    }





}